"use strict";

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var isString = function isString(x) {
  return typeof(x) === "string";
};

var getListLevel = function getListLevel(list) {
  var _Math;

  var numList = list.map(function (item) {
    return Array.isArray(item) ? getListLevel(item) + 1 : 1;
  });
  return (_Math = Math).max.apply(_Math, _toConsumableArray(numList));
};

var makeSpace = function makeSpace(buffer, n) {
  return n > 0 ? makeSpace(buffer + " ", n - 1) : buffer;
};

exports.spaces = function (n) {
  return makeSpace("", n);
};

exports.type = function (x) {
  var info = Object.prototype.toString.call(x),
      theType = info.slice(8, -1);
  return theType.toLowerCase();
};

exports.markToken = function (text) {
  return text.match(/^[^\"\s\(\)]+$/) ? text : JSON.stringify(text);
};

exports.isPlain = function (list) {
  return list.length === 0 ? true : list.every(function (child) {
    return exports.type(child) === "string";
  });
};

exports.isArray = function (x) {
  return exports.type(x) === "array";
};

exports.isDeep = function (ast) {
  return Array.isArray(ast) ? getListLevel(ast) > 2 : false;
};

exports.isSmallExpression = function (tree) {
  return tree.length === 0 || tree.length <= 3 && tree.every(isString);
};